<template>
  <div class="feedbacks">
    <ul
      class="feedbackList"
      v-if="feedbacks.length">
      <li
        v-for="feedback in feedbacks"
        :key="feedback.id"
        class="feedbackList-item">
        <Feedback
          :feedback="feedback"
          :auth-user="authUser"
          :is-same-user="isSameUser"
          @add-like="onAddLike"
          @login="$emit('login')"/>
      </li>
    </ul>
  </div>
</template>

<script>

import Feedback from '~/components/redesign/feedback/feedback';

export default {
  name: 'FeedbackList',
  components: {
    Feedback,
  },
  props: {
    feedbacks: {
      type: Array,
      default() { return []; },
    },
    authUser: {
      type: Object,
      default() { return {}; },
    },
    isSameUser: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    async onAddLike(id) {
      if (!this.authUser || !id) {
        return;
      }

      try {
        const { data } = await this.$axios.$post('/_main/feedback/addLike', {
          data: {
            feedbackId: Number(id),
          },
        });

        const currentFeedback = this.feedbacks.find(entry => Number(entry.id) === Number(data.id));
        currentFeedback.likersCount = data.likersCount;
      } catch (e) {
        console.error(e);
      }
    },
  },
};
</script>

<style lang="postcss">
  .feedbacks {
    display: block;
    width: 100%;

    &-count {
      color: var(--color-yellow);
    }

    .feedbackList {
      &-item {
        padding-bottom: 1rem;
      }
    }

    @media screen and (max-width: 980px) {
      .feedbackList-item {
        padding: 1.5rem 1.25rem 1rem;
        border-bottom: 1px solid var(--border-color-main);
      }
    }
  }

</style>
